Index: .hgsub
===================================================================
--- .hgsub	(revision 786)
+++ .hgsub	(revision 0)
@@ -1,1 +1,1 @@
-inc/libs/clearbricks = https://clearbricks.org/hg
+inc/libs/clearbricks = https://bitbucket.org/dotclear/clearbricks
Index: .hgsubstate
===================================================================
--- .hgsubstate	(revision 785)
+++ .hgsubstate	(revision 782)
@@ -1,1 +1,1 @@
-3cbd66dd535bb31029bfb0a7472393c7821e17e0 inc/libs/clearbricks
+cf8874ccc1fae0e9315d461497ff019f6dafeb7f inc/libs/clearbricks
Index: .hgtags
===================================================================
--- .hgtags	(revision 800)
+++ .hgtags	(revision 369)
@@ -1,7 +1,2 @@
 ec077f3c6b20bc6f7f40a113acaff0220457a2c4 2.3.0
 4e0137ddb12474d62b88c4966d5895a391b6d382 2.3.1
-43a9cace0f39c95463e66346dcc953ced40836be 2.4.2
-43a9cace0f39c95463e66346dcc953ced40836be 2.4.2
-0000000000000000000000000000000000000000 2.4.2
-0000000000000000000000000000000000000000 2.4.2
-6b3942c0cf7eee71ebd906ec0827c5962823dedf 2.4.2
Index: CHANGELOG
===================================================================
--- CHANGELOG	(revision 801)
+++ CHANGELOG	(revision 777)
@@ -1,18 +1,12 @@
-Dotclear 2.4.2 - 2012-02-11
-===========================================================
-* Security fix release
-* 4 XSS vulnerabilities fixed, discovered by High-Tech Bridge
-
-Dotclear 2.4.1.2 - 2011-12-24
-===========================================================
-* Happy Christmas!
-* Security: fixed one SQL injection vulnerability in Clearbricks, thanks to Adjaya
-* New behaviour: publicGetURLFor
-* New behaviour: publicRegisterURL
-* New behaviour: templatePrepareParams
+Dotclear 2.4.1-dev
+===========================================================
+* New behavior : publicGetURLFor
+* New behavior : publicRegisterURL
+* New behavior : templatePrepareParams
 * Changed the way to get artefacts URLs, through $core->url->getURLFor calls, instead of $core->url->getBase()
 * new/updated parameter sql_only in $core->blog->getPosts and $core->blog->getComments
 
-Dotclear 2.4.0 - 2011-11-13
+
+Dotclear 2.4.0
 ===========================================================
 * Admin: new iconset from Thomas Daveluy
@@ -27,5 +21,5 @@
 * Various bug fixes
 
-Dotclear 2.3.1 - 2011-06-14
+Dotclear 2.3.1 - 2001-06-14
 ===========================================================
 * Updated makefile for cleaner distrib.
Index: admin/auth.php
===================================================================
--- admin/auth.php	(revision 794)
+++ admin/auth.php	(revision 550)
@@ -31,5 +31,5 @@
 
 $change_pwd = $core->auth->allowPassChange() && isset($_POST['new_pwd']) && isset($_POST['new_pwd_c']) && isset($_POST['login_data']);
-$login_data = !empty($_POST['login_data']) ? html::escapeHTML($_POST['login_data']) : null;
+$login_data = !empty($_POST['login_data']) ? $_POST['login_data'] : null;
 $recover = $core->auth->allowPassChange() && !empty($_REQUEST['recover']);
 $safe_mode = !empty($_REQUEST['safe_mode']);
Index: admin/blogs.php
===================================================================
--- admin/blogs.php	(revision 792)
+++ admin/blogs.php	(revision 782)
@@ -15,26 +15,12 @@
 dcPage::check('usage,contentadmin');
 
-# Filters
-$sortby_combo = array(
-__('Last update') => 'blog_upddt',
-__('Blog name') => 'UPPER(blog_name)',
-__('Blog ID') => 'B.blog_id'
-);
+$q = !empty($_GET['q']) ? $_GET['q'] : '';
 
-$order_combo = array(
-__('Descending') => 'desc',
-__('Ascending') => 'asc'
-);
+$blogs_list = new adminBlogList($core);
 
-$q = !empty($_GET['q']) ? $_GET['q'] : '';
-$sortby = !empty($_GET['sortby']) ? $_GET['sortby'] : 'blog_upddt';
-$order = !empty($_GET['order']) ? $_GET['order'] : 'desc';
+$params = new ArrayObject();
 
-$page = !empty($_GET['page']) ? $_GET['page'] : 1;
-$nb_per_page =  30;
-
-if (!empty($_GET['nb']) && (integer) $_GET['nb'] > 0) {
-	$nb_per_page = (integer) $_GET['nb'];
-}
+# - Limit, sortby and order filter
+$params = $blogs_list->applyFilters($params);
 
 $show_filters = false;
@@ -46,21 +32,8 @@
 }
 
-# - Sortby and order filter
-if ($sortby !== '' && in_array($sortby,$sortby_combo)) {
-	if ($order !== '' && in_array($order,$order_combo)) {
-		$params['order'] = $sortby.' '.$order;
-	}
-	
-	if ($sortby != 'blog_upddt' || $order != 'desc') {
-		$show_filters = true;
-	}
-}
-
-$params['limit'] = array((($page-1)*$nb_per_page),$nb_per_page);
-
 try {
 	$counter = $core->getBlogs($params,1);
 	$rs = $core->getBlogs($params);
-	$nb_blog = $counter->f(0);
+	$blogs_list->setItems($rs,$counter->f(0));
 } catch (Exception $e) {
 	$core->error->add($e->getMessage());
@@ -93,23 +66,10 @@
 	echo
 	'<form action="blogs.php" method="get" id="filters-form">'.
-	'<fieldset class="two-cols"><legend>'.__('Filters').'</legend>'.
+	'<fieldset><legend>'.__('Filters').'</legend>'.
 	
-	'<div class="col">'.
-	'<p><label for="sortby">'.__('Order by:').' '.
-	form::combo('sortby',$sortby_combo,html::escapeHTML($sortby)).
-	'</label> '.
-	'<label for="order">'.__('Sort:').' '.
-	form::combo('order',$order_combo,html::escapeHTML($order)).
-	'</label></p>'.
-	'</div>'.
-	
-	'<div class="col">'.
 	'<p><label for="q">'.__('Search:').' '.
 	form::field('q',20,255,html::escapeHTML($q)).
 	'</label></p>'.
-	'<p><label for="nb" class="classic">'.	form::field('nb',3,3,$nb_per_page).' '.
-	__('Blogs per page').'</label> '.
-	'<input type="submit" value="'.__('Apply filters').'" /></p>'.
-	'</div>'.
+	'<p><input type="submit" value="'.__('Apply filters').'" /></p>'.
 	
 	'<br class="clear" />'. //Opera sucks
@@ -118,68 +78,8 @@
 	
 	# Show blogs
-	if ($nb_blog == 0)
-	{
-		echo '<p><strong>'.__('No blog').'</strong></p>';
-	}
-	else
-	{
-		$pager = new pager($page,$nb_blog,$nb_per_page,10);
-		$pager->var_page = 'page';
-		
-		echo '<p>'.__('Page(s)').' : '.$pager->getLinks().'</p>';
-		
-		echo
-		'<table class="clear"><tr>'.
-		'<th>'.__('Blog name').'</th>'.
-		'<th class="nowrap">'.__('Last update').'</th>'.
-		'<th class="nowrap">'.__('Entries').'</th>'.
-		'<th class="nowrap">'.__('Blog ID').'</th>'.
-		'<th>&nbsp;</th>'.
-		'<th class="nowrap">'.__('Status').'</th>'.
-		'</tr>';
-		
-		while ($rs->fetch()) {
-			echo blogLine($rs);
-		}
-		
-		echo '</table>';
-		
-		echo '<p>'.__('Page(s)').' : '.$pager->getLinks().'</p>';
-	}
+	$blogs_list->display();
 }
 
 dcPage::close();
 
-function blogLine($rs)
-{
-	global $core;
-	
-	$blog_id = html::escapeHTML($rs->blog_id);
-	$edit_link = '';
-	
-	if ($GLOBALS['core']->auth->isSuperAdmin()) {
-		$edit_link = 
-		'<a href="blog.php?id='.$blog_id.'" '.
-		'title="'.sprintf(__('Edit blog %s'),$blog_id).'">'.
-		__('edit').'</a>';
-	}
-	
-	$img_status = $rs->blog_status == 1 ? 'check-on' : 'check-off';
-	$txt_status = $GLOBALS['core']->getBlogStatus($rs->blog_status);
-	$img_status = sprintf('<img src="images/%1$s.png" alt="%2$s" title="%2$s" />',$img_status,$txt_status);
-	$offset = dt::getTimeOffset($core->auth->getInfo('user_tz'));
-	$blog_upddt = dt::str(__('%Y-%m-%d %H:%M'),strtotime($rs->blog_upddt) + $offset);
-	
-	return
-	'<tr class="line">'.
-	'<td class="maximal"><a href="index.php?switchblog='.$rs->blog_id.'" '.
-	'title="'.sprintf(__('Switch to blog %s'),$rs->blog_id).'">'.
-	html::escapeHTML($rs->blog_name).'</a></td>'.
-	'<td class="nowrap">'.$blog_upddt.'</td>'.
-	'<td class="nowrap">'.$core->countBlogPosts($rs->blog_id).'</td>'.
-	'<td class="nowrap">'.$blog_id.'</td>'.
-	'<td>'.$edit_link.'</td>'.
-	'<td class="status">'.$img_status.'</td>'.
-	'</tr>';
-}
 ?>
Index: admin/comments.php
===================================================================
--- admin/comments.php	(revision 796)
+++ admin/comments.php	(revision 783)
@@ -15,9 +15,21 @@
 dcPage::check('usage,contentadmin');
 
+class authorFilter extends textFilter {
+	public function header() {
+		return 
+			dcPage::jqueryUI().
+			dcPage::jsLoad('js/author_filter.js')
+			;
+	}
+	public function applyFilter($params) {
+		$val = preg_split('/\s*,\s*/',$this->values[0]);
+		$params[$this->request_param]=$val;
+	}
+}
+
+
 # Creating filter combo boxes
 # Filter form we'll put in html_block
-$status_combo = array(
-'-' => ''
-);
+$status_combo = array();
 foreach ($core->blog->getAllCommentStatus() as $k => $v) {
 	$status_combo[$v] = (string) $k;
@@ -25,100 +37,17 @@
 
 $type_combo = array(
-'-' => '',
-__('comment') => 'co',
-__('trackback') => 'tb'
+__('comment') => '0',
+__('trackback') => '1'
 );
 
-$sortby_combo = array(
-__('Date') => 'comment_dt',
-__('Entry title') => 'post_title',
-__('Author') => 'comment_author',
-__('Status') => 'comment_status'
-);
+$comment_list = new adminCommentList($core);
 
-$order_combo = array(
-__('Descending') => 'desc',
-__('Ascending') => 'asc'
-);
-
-
-/* Get comments
--------------------------------------------------------- */
-$author = isset($_GET['author']) ?	$_GET['author'] : '';
-$status = isset($_GET['status']) ?		$_GET['status'] : '';
-$type = !empty($_GET['type']) ?		$_GET['type'] : '';
-$sortby = !empty($_GET['sortby']) ?	$_GET['sortby'] : 'comment_dt';
-$order = !empty($_GET['order']) ?		$_GET['order'] : 'desc';
-$ip = !empty($_GET['ip']) ?			$_GET['ip'] : '';
-
-$with_spam = $author || $status || $type || $sortby != 'comment_dt' || $order != 'desc' || $ip;
-
-$show_filters = false;
-
-$page = !empty($_GET['page']) ? (integer) $_GET['page'] : 1;
-$nb_per_page =  30;
-
-if (!empty($_GET['nb']) && (integer) $_GET['nb'] > 0) {
-	if ($nb_per_page != $_GET['nb']) {
-		$show_filters = true;
-	}
-	$nb_per_page = (integer) $_GET['nb'];
-}
-
-$params['limit'] = array((($page-1)*$nb_per_page),$nb_per_page);
+$params = new ArrayObject();
 $params['no_content'] = true;
 
-# Author filter
-if ($author !== '') {
-	$params['q_author'] = $author;
-	$show_filters = true;
-} else {
-	$author='';
-}
-
-# - Type filter
-if ($type == 'tb' || $type == 'co') {
-	$params['comment_trackback'] = ($type == 'tb');
-	$show_filters = true;
-} else {
-	$type='';
-}
-
-# - Status filter
-if ($status !== '' && in_array($status,$status_combo)) {
-	$params['comment_status'] = $status;
-	$show_filters = true;
-} elseif (!$with_spam) {
-	$params['comment_status_not'] = -2;
-	$status='';
-} else {
-	$status='';
-}
-
-# - IP filter
-if ($ip) {
-	$params['comment_ip'] = $ip;
-	$show_filters = true;
-}
-
-# Sortby and order filter
-if ($sortby !== '' && in_array($sortby,$sortby_combo)) {
-	if ($order !== '' && in_array($order,$order_combo)) {
-		$params['order'] = $sortby.' '.$order;
-	} else {
-		$order = 'desc';
-	}
-	
-	if ($sortby != 'comment_dt' || $order != 'desc') {
-		$show_filters = true;
-	}
-} else {
-	$sortby = 'comment_dt';
-	$order = 'desc';
-}
+# - Limit, sortby and order filter
 
 # Actions combo box
 $combo_action = array();
-$default = '';
 if ($core->auth->check('publish,contentadmin',$core->blog->id))
 {
@@ -130,8 +59,5 @@
 if ($core->auth->check('delete,contentadmin',$core->blog->id))
 {
-	$combo_action[__('Delete')] = 'delete';
-	if ($status == -2) {
-		$default = 'delete';
-	}
+	$combo_action[__('delete')] = 'delete';
 }
 
@@ -139,10 +65,42 @@
 $core->callBehavior('adminCommentsActionsCombo',array(&$combo_action));
 
+$filterSet = new dcFilterSet('comments','comments.php');
+
+$authorFilter = new authorFilter(
+		'author',__('Author'), __('Author'),'comment_author',20,255);
+$filterSet
+	->addFilter(new comboFilter(
+		'status',__('Status'), __('Status'), 'comment_status', $status_combo))
+	->addFilter(new booleanFilter(
+		'type',__('Type'), __('Type'), 'comment_trackback', $type_combo))
+	->addFilter($authorFilter)
+	->addFilter(new textFilter(
+		'ip',__('IP address'), __('IP address'), 'comment_ip',20,39));
+		
+$core->callBehavior('adminCommentsFilters',$filterSet);
+$filterSet->setExtra($comment_list);
+
+$filterSet->setup($_GET,$_POST);
+if (isset($_GET['author'])) {
+	$authorFilter->add();
+	$authorFilter->setValues($_GET['author']);
+}
+$with_spam=true;
 /* Get comments
 -------------------------------------------------------- */
 try {
+	$nfparams = $params->getArrayCopy();
+	$filtered = $filterSet->applyFilters($params);
+	$core->callBehavior('adminCommentsParams',$params);
 	$comments = $core->blog->getComments($params);
 	$counter = $core->blog->getComments($params,true);
-	$comment_list = new adminCommentList($core,$comments,$counter->f(0));
+	if ($filtered) {
+		$totalcounter = $core->blog->getComments($nfparams,true);
+		$page_title = sprintf(__('Comments and Trackacks / %s filtered out of %s'),$counter->f(0),$totalcounter->f(0));
+	} else {
+		$page_title = __('Comments and Trackacks');
+	}
+
+	$comment_list->setItems($comments,$counter->f(0));
 } catch (Exception $e) {
 	$core->error->add($e->getMessage());
@@ -151,8 +109,6 @@
 /* DISPLAY
 -------------------------------------------------------- */
-$starting_script = dcPage::jsLoad('js/_comments.js');
-if (!$show_filters) {
-	$starting_script .= dcPage::jsLoad('js/filter-controls.js');
-}
+$starting_script = dcPage::jsLoad('js/_comments.js').$filterSet->header();
+
 # --BEHAVIOR-- adminCommentsHeaders
 $starting_script .= $core->callBehavior('adminCommentsHeaders');
@@ -165,47 +121,5 @@
 {
 	# Filters
-	if (!$show_filters) {
-		echo '<p><a id="filter-control" class="form-control" href="#">'.
-		__('Filters').'</a></p>';
-	}
-	
-	echo
-	'<form action="comments.php" method="get" id="filters-form">'.
-	'<fieldset><legend>'.__('Filters').'</legend>'.
-	'<div class="three-cols">'.
-	'<div class="col">'.
-	'<label for="type">'.__('Type:').' '.
-	form::combo('type',$type_combo,$type).
-	'</label> '.
-	'<label for="status">'.__('Status:').' '.
-	form::combo('status',$status_combo,$status).
-	'</label>'.
-	'</div>'.
-	
-	'<div class="col">'.
-	'<p><label for="sortby">'.__('Order by:').' '.
-	form::combo('sortby',$sortby_combo,$sortby).
-	'</label> '.
-	'<label for="order">'.__('Sort:').' '.
-	form::combo('order',$order_combo,$order).
-	'</label></p>'.
-	'<p><label for="nb" class="classic">'.	form::field('nb',3,3,$nb_per_page).' '.
-	__('Comments per page').'</label></p>'.
-	'</div>'.
-	
-	'<div class="col">'.
-	'<p><label for="author">'.__('Comment author:').' '.
-	form::field('author',20,255,html::escapeHTML($author)).
-	'</label>'.
-	'<label for="ip">'.__('IP address:').' '.
-	form::field('ip',20,39,html::escapeHTML($ip)).
-	'</label></p>'.
-	'<p><input type="submit" value="'.__('Apply filters').'" /></p>'.
-	'</div>'.
-	
-	'</div>'.
-	'<br class="clear" />'. //Opera sucks
-	'</fieldset>'.
-	'</form>';
+	$filterSet->display();
 	
 	if (!$with_spam) {
@@ -221,6 +135,5 @@
 	
 	# Show comments
-	$comment_list->display($page,$nb_per_page,
-	'<form action="comments_actions.php" method="post" id="form-comments">'.
+	$comment_list->display('<form action="comments_actions.php" method="post" id="form-comments">'.
 	
 	'%s'.
@@ -230,15 +143,8 @@
 	
 	'<p class="col right"><label for="action" class="classic">'.__('Selected comments action:').'</label> '.
-	form::combo('action',$combo_action,$default,'','','','title="'.__('action: ').'"').
+	form::combo('action',$combo_action,'','','','','title="'.__('action: ').'"').
 	$core->formNonce().
 	'<input type="submit" value="'.__('ok').'" /></p>'.
-	form::hidden(array('type'),$type).
-	form::hidden(array('sortby'),$sortby).
-	form::hidden(array('order'),$order).
-	form::hidden(array('author'),preg_replace('/%/','%%',$author)).
-	form::hidden(array('status'),$status).
-	form::hidden(array('ip'),preg_replace('/%/','%%',$ip)).
-	form::hidden(array('page'),$page).
-	form::hidden(array('nb'),$nb_per_page).
+	str_replace('%','%%',$filterSet->getFormFieldsAsHidden()).
 	'</div>'.
 	
Index: admin/comments_actions.php
===================================================================
--- admin/comments_actions.php	(revision 270)
+++ admin/comments_actions.php	(revision 782)
@@ -30,12 +30,5 @@
 	{
 		$redir =
-		'comments.php?type='.$_POST['type'].
-		'&author='.$_POST['author'].
-		'&status='.$_POST['status'].
-		'&sortby='.$_POST['sortby'].
-		'&ip='.$_POST['ip'].
-		'&order='.$_POST['order'].
-		'&page='.$_POST['page'].
-		'&nb='.(integer) $_POST['nb'];
+		'comments.php?'.urldecode($_POST['f_query']);
 	}
 	
Index: admin/js/author_filter.js
===================================================================
--- admin/js/author_filter.js	(revision 781)
+++ admin/js/author_filter.js	(revision 781)
@@ -0,0 +1,58 @@
+function split( val ) {
+	return val.split( /,\s*/ );
+}
+function extractLast(term) {
+	return split(term).pop();
+}
+
+$(function() {
+	$('#f_author')
+	.bind( "keydown", function( event ) {
+		if ( event.keyCode === $.ui.keyCode.TAB &&
+				$( this ).data( "autocomplete" ).menu.active ) {
+			event.preventDefault();
+		}
+	})
+	.autocomplete({
+		minLength: 2,
+		delay: 1000,
+		source: function(request,response) {
+			$.ajax({
+				url: 'services.php',
+				data: {
+					'f': 'searchCommentAuthor',
+					'q': extractLast(request.term)
+				},
+				success:function(data,status) {
+					results = [];
+					$(data).find('author').each(function(){
+						var name = $(this).attr('name');
+						results.push({label:name,value:name});
+					});
+					response(results);
+				}
+			});
+		},
+		search: function() {
+			var term = extractLast( this.value );
+			if ( term.length < 2 ) {
+				return false;
+			}
+		},
+		focus: function() {
+			// prevent value inserted on focus
+			return false;
+		},
+		select: function( event, ui ) {
+			var terms = split( this.value );
+			// remove the current input
+			terms.pop();
+			// add the selected item
+			terms.push( ui.item.value );
+			// add placeholder to get the comma-and-space at the end
+			terms.push( "" );
+			this.value = terms.join( ", " );
+			return false;
+		}		
+	});
+});
Index: admin/js/filters.js
===================================================================
--- admin/js/filters.js	(revision 783)
+++ admin/js/filters.js	(revision 783)
@@ -0,0 +1,6 @@
+$(function() {
+	$('#toggle-filters').click(function(e) {
+		$('#filters').toggleClass('hidden');
+		$('#toggle-filters').toggleClass('opened');
+	});
+});
Index: admin/langs.php
===================================================================
--- admin/langs.php	(revision 500)
+++ admin/langs.php	(revision 782)
@@ -173,8 +173,10 @@
 {
 	echo
-	'<table class="clear plugins"><tr>'.
-	'<th>'.__('Language').'</th>'.
-	'<th class="nowrap">'.__('Action').'</th>'.
-	'</tr>';
+	'<table class="clear plugins">'.
+	'<thead><tr>'.
+	'<th scope="col">'.__('Language').'</th>'.
+	'<th scope="col" class="nowrap">'.__('Action').'</th>'.
+	'</tr></thead>'.
+	'<tbody>';
 	
 	foreach ($locales_content as $k => $v)
@@ -184,6 +186,6 @@
 		echo
 		'<tr class="line wide">'.
-		'<td class="maximal nowrap">('.$k.') '.
-		'<strong>'.html::escapeHTML($iso_codes[$k]).'</strong></td>'.
+		'<th scope="row" class="maximal nowrap">('.$k.') '.
+		'<strong>'.html::escapeHTML($iso_codes[$k]).'</strong></th>'.
 		'<td class="nowrap action">';
 		
@@ -202,5 +204,7 @@
 		echo '</td></tr>';
 	}
-	echo '</table>';
+	echo
+	'</tbody>'.
+	'</table>';
 }
 
@@ -228,5 +232,5 @@
 	'Proposed languages are based on your version: %s.'),'<strong>'.DC_VERSION.'</strong>').'</p>'.
 	'<p class="field"><label for="pkg_url" class="classic">'.__('Language:').' '.
-	form::combo(array('pkg_url'),$dc_langs_combo).'</label></p>'.
+	form::combo('pkg_url',$dc_langs_combo).'</label></p>'.
 	'<p class="field"><label for="your_pwd1" class="classic required"><abbr title="'.__('Required field').'">*</abbr> '.__('Your password:').' '.
 	form::password(array('your_pwd','your_pwd1'),20,255).'</label></p>'.
Index: admin/permissions_blog.php
===================================================================
--- admin/permissions_blog.php	(revision 557)
+++ admin/permissions_blog.php	(revision 782)
@@ -4,5 +4,5 @@
 # This file is part of Dotclear 2.
 #
-# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2010 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
@@ -15,19 +15,5 @@
 dcPage::checkSuper();
 
-# Filters
-$sortby_combo = array(
-__('Blog ID') => 'B.blog_id',
-__('Blog name') => 'blog_name'
-);
-
-$order_combo = array(
-__('Descending') => 'desc',
-__('Ascending') => 'asc'
-);
-
 $q = !empty($_GET['q']) ? $_GET['q'] : '';
-$sortby = !empty($_GET['sortby']) ? $_GET['sortby'] : 'blog_id';
-$order = !empty($_GET['order']) ? $_GET['order'] : 'asc';
-
 
 # Check users
@@ -48,10 +34,10 @@
 else
 {
-	$page = !empty($_GET['page']) ? $_GET['page'] : 1;
-	$nb_per_page =  30;
+	$blogs_list = new adminBlogPermissionsList($core);
 	
-	if (!empty($_GET['nb']) && (integer) $_GET['nb'] > 0) {
-		$nb_per_page = $_GET['nb'];
-	}
+	$params = new ArrayObject();
+	
+	# - Limit, sortby and order filter
+	$params = $blogs_list->applyFilters($params);
 	
 	$show_filters = false;
@@ -63,18 +49,8 @@
 	}
 	
-	# - Sortby and order filter
-	if ($sortby !== '' && in_array($sortby,$sortby_combo)) {
-		if ($order !== '' && in_array($order,$order_combo)) {
-			$params['order'] = $sortby.' '.$order;
-			$show_filters = true;
-		}
-	}
-	
-	$params['limit'] = array((($page-1)*$nb_per_page),$nb_per_page);
-	
 	try {
 		$rs = $core->getBlogs($params);
 		$counter = $core->getBlogs($params,1);
-		$nb_blog = $counter->f(0);
+		$blogs_list->setItems($rs,$counter->f(0));
 	} catch (Exception $e) {
 		$core->error->add($e->getMessage());
@@ -90,5 +66,5 @@
 dcPage::open(__('choose a blog'),$starting_script);
 
-echo '<h2><a href="users.php">'.__('Users').'</a> &rsaquo; <span class="page-title">'.__('Choose a blog').'</span></h2>';
+echo '<h2><a href="users.php">'.__('Users').'</a> &rsaquo; '.__('Choose a blog').'</h2>';
 
 if (!$core->error->flag())
@@ -107,14 +83,4 @@
 	'<fieldset class="two-cols"><legend>'.__('Filters').'</legend>'.
 	
-	'<div class="col">'.
-	'<p><label for="sortby">'.__('Order by:').' '.
-	form::combo('sortby',$sortby_combo,html::escapeHTML($sortby)).
-	'</label> '.
-	'<label for="order">'.__('Sort:').' '.
-	form::combo('order',$order_combo,html::escapeHTML($order)).
-	'</label></p>'.
-	'</div>'.
-	
-	'<div class="col">'.
 	'<p><label for="q">'.__('Search:').' '.
 	form::field('q',20,255,html::escapeHTML($q)).
@@ -124,5 +90,4 @@
 	'<input type="submit" value="'.__('Apply filters').'" />'.
 	$hidden_fields.'</p>'.
-	'</div>'.
 	
 	'<br class="clear" />'. //Opera sucks
@@ -136,61 +101,16 @@
 	
 	# Show blogs
-	if ($nb_blog == 0)
-	{
-		echo '<p><strong>'.__('No blog').'</strong></p>';
-	}
-	else
-	{
-		$pager = new pager($page,$nb_blog,$nb_per_page,10);
-		$pager->var_page = 'page';
-		
-		echo '<p>'.__('Page(s)').' : '.$pager->getLinks().'</p>';
-		
-		echo
-		'<form action="permissions.php" method="post" id="form-blogs">'.
-		'<table class="clear"><tr>'.
-		'<th colspan="2">'.__('Blog ID').'</th>'.
-		'<th>'.__('Blog name').'</th>'.
-		'<th class="nowrap">'.__('Entries').'</th>'.
-		'<th class="nowrap">'.__('Status').'</th>'.
-		'</tr>';
-		
-		while ($rs->fetch()) {
-			echo blogLine($rs);
-		}
-		
-		echo
-		'</table>'.
-		
+	$blogs_list->display('<form action="permissions.php" method="post" id="form-blogs">'.
+		'%s'.
 		'<p class="checkboxes-helpers"></p>'.
 		
-		'<p><input type="submit" value="'.__('Set permissions').'" />'.
+		'<p><input type="submit" value="'.__('set permissions').'" />'.
 		$hidden_fields.
 		$core->formNonce().'</p>'.
-		'</form>';
-		
-		echo '<p>'.__('Page(s)').' : '.$pager->getLinks().'</p>';
-	}
+		'</form>'
+	);
 }
 
 dcPage::close();
 
-function blogLine($rs)
-{
-	global $core;
-	
-	$img_status = $rs->blog_status == 1 ? 'check-on' : 'check-off';
-	$txt_status = $GLOBALS['core']->getBlogStatus($rs->blog_status);
-	$img_status = sprintf('<img src="images/%1$s.png" alt="%2$s" title="%2$s" />',$img_status,$txt_status);
-	
-	return
-	'<tr class="line">'.
-	'<td class="nowrap">'.
-	form::checkbox(array('blog_id[]'),$rs->blog_id,'','','',false,'title="'.__('select').' '.$rs->blog_id.'"').'</td>'.
-	'<td class="nowrap">'.$rs->blog_id.'</td>'.
-	'<td class="maximal">'.html::escapeHTML($rs->blog_name).'</td>'.
-	'<td class="nowrap">'.$core->countBlogPosts($rs->blog_id).'</td>'.
-	'<td class="status">'.$img_status.'</td>'.
-	'</tr>';
-}
 ?>
Index: admin/plugins.php
===================================================================
--- admin/plugins.php	(revision 500)
+++ admin/plugins.php	(revision 782)
@@ -227,10 +227,13 @@
 	echo
 	'<h3>'.__('Activated plugins').'</h3>'.
-	'<table class="clear plugins"><tr>'.
-	'<th>'.__('Plugin').'</th>'.
-	'<th class="nowrap">'.__('Version').'</th>'.
-	'<th class="nowrap">'.__('Details').'</th>'.
-	'<th class="nowrap">'.__('Action').'</th>'.
-	'</tr>';
+	'<table class="clear plugins">'.
+	'<caption>'.__('Activated plugin list').'</caption>'.
+	'<thead><tr>'.
+	'<th scope="col">'.__('Plugin').'</th>'.
+	'<th scope="col" class="nowrap">'.__('Version').'</th>'.
+	'<th scope="col" class="nowrap">'.__('Details').'</th>'.
+	'<th scope="col" class="nowrap">'.__('Action').'</th>'.
+	'</tr></thead>'.
+	'<tbody>';
 	
 	foreach ($p_available as $k => $v)
@@ -241,5 +244,5 @@
 		echo
 		'<tr class="line wide">'.
-		'<td class="minimal nowrap"><strong>'.html::escapeHTML($k).'</strong></td>'.
+		'<th scope="row" class="minimal nowrap"><strong>'.html::escapeHTML($k).'</strong></th>'.
 		'<td class="minimal">'.html::escapeHTML($v['version']).'</td>'.
 		'<td class="maximal"><strong>'.html::escapeHTML($v['name']).'</strong> '.
@@ -265,4 +268,5 @@
 	}
 	echo
+	'</tbody>'.
 	'</table>';
 }
@@ -274,8 +278,11 @@
 	echo
 	'<h3>'.__('Deactivated plugins').'</h3>'.
-	'<table class="clear plugins"><tr>'.
-	'<th>'.__('Plugin').'</th>'.
-	'<th class="nowrap">'.__('Action').'</th>'.
-	'</tr>';
+	'<table class="clear plugins">'.
+	'<caption>'.__('Deactivated plugin list').'</caption>'.
+	'<thead><tr>'.
+	'<th scope="col">'.__('Plugin').'</th>'.
+	'<th scope="col" class="nowrap">'.__('Action').'</th>'.
+	'</tr></thead>'.
+	'<tbody>';
 	
 	foreach ($p_disabled as $k => $v)
@@ -286,5 +293,5 @@
 		echo
 		'<tr class="line wide">'.
-		'<td class="maximal nowrap"><strong>'.html::escapeHTML($k).'</strong></td>'.
+		'<th scope="row" class="maximal nowrap"><strong>'.html::escapeHTML($k).'</strong></th>'.
 		'<td class="nowrap action">';
 		
@@ -308,4 +315,5 @@
 	}
 	echo
+	'</tbody>'.
 	'</table>';
 }
Index: admin/popup_posts.php
===================================================================
--- admin/popup_posts.php	(revision 557)
+++ admin/popup_posts.php	(revision 782)
@@ -17,11 +17,11 @@
 $q = !empty($_GET['q']) ? $_GET['q'] : null;
 
-$page = !empty($_GET['page']) ? (integer) $_GET['page'] : 1;
-$nb_per_page =  10;
+$post_list = new adminPostMiniList($core);
 
 $params = array();
-$params['limit'] = array((($page-1)*$nb_per_page),$nb_per_page);
 $params['no_content'] = true;
-$params['order'] = 'post_dt DESC';
+
+# - Limit, sortby and order filter
+$params = $post_list->applyFilters($params);
 
 if ($q) {
@@ -43,5 +43,5 @@
 	$posts = $core->blog->getPosts($params);
 	$counter = $core->blog->getPosts($params,true);
-	$post_list = new adminPostMiniList($core,$posts,$counter->f(0));
+	$post_list->setItems($posts,$counter->f(0));
 } catch (Exception $e) {
 	$core->error->add($e->getMessage());
@@ -49,5 +49,5 @@
 
 echo '<div id="form-entries">'; # I know it's not a form but we just need the ID
-$post_list->display($page,$nb_per_page);
+$post_list->display();
 echo '</div>';
 
Index: admin/post.php
===================================================================
--- admin/post.php	(revision 776)
+++ admin/post.php	(revision 782)
@@ -573,11 +573,14 @@
 {
 	echo
-	'<table class="comments-list"><tr>'.
-	'<th colspan="2">'.__('Author').'</th>'.
-	'<th>'.__('Date').'</th>'.
-	'<th class="nowrap">'.__('IP address').'</th>'.
-	'<th>'.__('Status').'</th>'.
-	'<th>&nbsp;</th>'.
-	'</tr>';
+	'<table class="comments-list">'.
+	'<caption>'.__('Post comments and trackbacks').'</caption>'.
+	'<thead><tr>'.
+	'<th scope="col" colspan="2">'.__('Author').'</th>'.
+	'<th scope="col">'.__('Date').'</th>'.
+	'<th scope="col" class="nowrap">'.__('IP address').'</th>'.
+	'<th scope="col">'.__('Status').'</th>'.
+	'<th scope="col">&nbsp;</th>'.
+	'</tr></thead>'.
+	'<tbody>';
 	
 	while($rs->fetch())
@@ -607,5 +610,5 @@
 		'<td class="nowrap">'.
 		($has_action ? form::checkbox(array('comments[]'),$rs->comment_id,'','','',0,'title="'.($tb ? __('select this trackback') : __('select this comment')).'"') : '').'</td>'.
-		'<td class="maximal">'.html::escapeHTML($rs->comment_author).'</td>'.
+		'<th scope="row" class="maximal">'.html::escapeHTML($rs->comment_author).'</th>'.
 		'<td class="nowrap">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$rs->comment_dt).'</td>'.
 		'<td class="nowrap"><a href="comments.php?ip='.$rs->comment_ip.'">'.$rs->comment_ip.'</a></td>'.
@@ -617,5 +620,7 @@
 	}
 	
-	echo '</table>';
+	echo
+	'</tbody>'.
+	'</table>';
 }
 
